com.fasterxml.jackson.databind.ser.impl

## Class UnwrappingBeanSerializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializer<T>
  - - com.fasterxml.jackson.databind.ser.std.StdSerializer<Object>
    - - com.fasterxml.jackson.databind.ser.std.BeanSerializerBase
      - - com.fasterxml.jackson.databind.ser.impl.UnwrappingBeanSerializer

- All Implemented Interfaces:
    JsonFormatVisitable, SchemaAware, ContextualSerializer, ResolvableSerializer, Serializable

      public class UnwrappingBeanSerializer
      extends BeanSerializerBase

  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonSerializer

      `JsonSerializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected NameTransformer` | `_nameTransformer` Transformer used to add prefix and/or suffix for properties of unwrapped POJO.

    - ### Fields inherited from class com.fasterxml.jackson.databind.ser.std.BeanSerializerBase

      `_anyGetterWriter, _filteredProps, _objectIdWriter, _propertyFilterId, _props, _serializationShape, _typeId, NAME_FOR_OBJECT_REF, NO_PROPS`

    - ### Fields inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

      `_handledType`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `UnwrappingBeanSerializer(BeanSerializerBase src, NameTransformer transformer)` Constructor used for creating unwrapping instance of a standard `BeanSerializer`
    `` | `UnwrappingBeanSerializer(UnwrappingBeanSerializer src, ObjectIdWriter objectIdWriter)`
    `` | `UnwrappingBeanSerializer(UnwrappingBeanSerializer src, ObjectIdWriter objectIdWriter, Object filterId)`
    `protected` | `UnwrappingBeanSerializer(UnwrappingBeanSerializer src, String[] toIgnore)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected BeanSerializerBase` | `asArraySerializer()` JSON Array output can not be done if unwrapping operation is requested; so implementation will simply return 'this'.
    `boolean` | `isUnwrappingSerializer()` Accessor for checking whether this serializer is an "unwrapping" serializer; this is necessary to know since it may also require caller to suppress writing of the leading property name.
    `void` | `serialize(Object bean, com.fasterxml.jackson.core.JsonGenerator jgen, SerializerProvider provider)` Main serialization method that will delegate actual output to configured `BeanPropertyWriter` instances.
    `void` | `serializeWithType(Object bean, com.fasterxml.jackson.core.JsonGenerator jgen, SerializerProvider provider, TypeSerializer typeSer)` Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.
    `String` | `toString()`
    `JsonSerializer<Object>` | `unwrappingSerializer(NameTransformer transformer)` Method that will return serializer instance that produces "unwrapped" serialization, if applicable for type being serialized (which is the case for some serializers that produce JSON Objects as output).
    `BeanSerializerBase` | `withFilterId(Object filterId)` Mutant factory used for creating a new instance with different filter id (used with `JsonFilter` annotation)
    `protected BeanSerializerBase` | `withIgnorals(String[] toIgnore)` Mutant factory used for creating a new instance with additional set of properties to ignore (from properties this instance otherwise has)
    `BeanSerializerBase` | `withObjectIdWriter(ObjectIdWriter objectIdWriter)` Mutant factory used for creating a new instance with different `ObjectIdWriter`.

    - ### Methods inherited from class com.fasterxml.jackson.databind.ser.std.BeanSerializerBase

      `_customTypeId, _serializeObjectId, _serializeWithObjectId, _serializeWithObjectId, acceptJsonFormatVisitor, createContextual, findConvertingSerializer, getSchema, properties, resolve, serializeFields, serializeFieldsFiltered, usesObjectId`

    - ### Methods inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

      `createObjectNode, createSchemaNode, createSchemaNode, findConvertingContentSerializer, findPropertyFilter, getSchema, handledType, isDefaultSerializer, wrapAndThrow, wrapAndThrow`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonSerializer

      `getDelegatee, isEmpty, isEmpty, replaceDelegatee`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.fasterxml.jackson.databind.jsonschema.SchemaAware

      `getSchema`

- - ### Field Detail

    - #### _nameTransformer

          protected final NameTransformer _nameTransformer

      Transformer used to add prefix and/or suffix for properties of unwrapped POJO.

  - ### Constructor Detail

    - #### UnwrappingBeanSerializer

          public UnwrappingBeanSerializer(BeanSerializerBase src,
                                          NameTransformer transformer)

      Constructor used for creating unwrapping instance of a standard `BeanSerializer`

    - #### UnwrappingBeanSerializer

          public UnwrappingBeanSerializer(UnwrappingBeanSerializer src,
                                          ObjectIdWriter objectIdWriter)

    - #### UnwrappingBeanSerializer

          public UnwrappingBeanSerializer(UnwrappingBeanSerializer src,
                                          ObjectIdWriter objectIdWriter,
                                          Object filterId)

    - #### UnwrappingBeanSerializer

          protected UnwrappingBeanSerializer(UnwrappingBeanSerializer src,
                                             String[] toIgnore)

  - ### Method Detail

    - #### unwrappingSerializer

          public JsonSerializer<Object> unwrappingSerializer(NameTransformer transformer)

      Description copied from class: `JsonSerializer`
      Method that will return serializer instance that produces "unwrapped" serialization, if applicable for type being serialized (which is the case for some serializers that produce JSON Objects as output). If no unwrapped serializer can be constructed, will simply return serializer as-is.

      Default implementation just returns serializer as-is, indicating that no unwrapped variant exists

      Overrides:
        `unwrappingSerializer` in class `JsonSerializer<Object>`
      Parameters:
        `transformer` - Name transformation to use to convert between names of unwrapper properties

    - #### isUnwrappingSerializer

          public boolean isUnwrappingSerializer()

      Description copied from class: `JsonSerializer`
      Accessor for checking whether this serializer is an "unwrapping" serializer; this is necessary to know since it may also require caller to suppress writing of the leading property name.
      Overrides:
        `isUnwrappingSerializer` in class `JsonSerializer<Object>`

    - #### withObjectIdWriter

          public BeanSerializerBase withObjectIdWriter(ObjectIdWriter objectIdWriter)

      Description copied from class: `BeanSerializerBase`
      Mutant factory used for creating a new instance with different `ObjectIdWriter`.
      Specified by:
        `withObjectIdWriter` in class `BeanSerializerBase`

    - #### withFilterId

          public BeanSerializerBase withFilterId(Object filterId)

      Description copied from class: `BeanSerializerBase`
      Mutant factory used for creating a new instance with different filter id (used with `JsonFilter` annotation)
      Specified by:
        `withFilterId` in class `BeanSerializerBase`

    - #### withIgnorals

          protected BeanSerializerBase withIgnorals(String[] toIgnore)

      Description copied from class: `BeanSerializerBase`
      Mutant factory used for creating a new instance with additional set of properties to ignore (from properties this instance otherwise has)
      Specified by:
        `withIgnorals` in class `BeanSerializerBase`

    - #### asArraySerializer

          protected BeanSerializerBase asArraySerializer()

      JSON Array output can not be done if unwrapping operation is requested; so implementation will simply return 'this'.
      Specified by:
        `asArraySerializer` in class `BeanSerializerBase`

    - #### serialize

          public final void serialize(Object bean,
                                      com.fasterxml.jackson.core.JsonGenerator jgen,
                                      SerializerProvider provider)
                               throws IOException,
                                      com.fasterxml.jackson.core.JsonGenerationException

      Main serialization method that will delegate actual output to configured `BeanPropertyWriter` instances.
      Specified by:
        `serialize` in class `BeanSerializerBase`
      Parameters:
        `bean` - Value to serialize; can not be null.
        `jgen` - Generator used to output resulting Json content
        `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
      Throws:
        `IOException`
        `com.fasterxml.jackson.core.JsonGenerationException`

    - #### serializeWithType

          public void serializeWithType(Object bean,
                                        com.fasterxml.jackson.core.JsonGenerator jgen,
                                        SerializerProvider provider,
                                        TypeSerializer typeSer)
                                 throws IOException,
                                        com.fasterxml.jackson.core.JsonGenerationException

      Description copied from class: `JsonSerializer`
      Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.

      Default implementation will throw `UnsupportedOperationException` to indicate that proper type handling needs to be implemented.

      For simple datatypes written as a single scalar value (JSON String, Number, Boolean), implementation would look like:

            // note: method to call depends on whether this type is serialized as JSON scalar, object or Array!
            typeSer.writeTypePrefixForScalar(value, gen);
            serialize(value, gen, provider);
            typeSer.writeTypeSuffixForScalar(value, gen);

      and implementations for type serialized as JSON Arrays or Objects would differ slightly, as `START-ARRAY>`/`END-ARRAY` and `START-OBJECT>`/`END-OBJECT` pairs need to be properly handled with respect to serializing of contents.
      Overrides:
        `serializeWithType` in class `BeanSerializerBase`
      Parameters:
        `bean` - Value to serialize; can not be null.
        `jgen` - Generator used to output resulting Json content
        `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
        `typeSer` - Type serializer to use for including type information
      Throws:
        `IOException`
        `com.fasterxml.jackson.core.JsonGenerationException`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

Copyright © 2014–2015 FasterXML. All rights reserved.